---
title: place-items
slug: Web/CSS/place-items
tags:
  - CSS
  - CSS Flexible Boxes
  - CSS Grid
  - CSS Property
  - Reference
  - 'recipe:css-shorthand-property'
---
<div>{{CSSRef}}</div>

<p>The <a href="/en-US/docs/Web/CSS">CSS</a> <strong><code>place-items</code></strong> <a href="/en-US/docs/Web/CSS/Shorthand_properties">shorthand property</a> allows you to align items along both the block and inline directions at once (i.e. the {{CSSxRef("align-items")}} and {{CSSxRef("justify-items")}} properties) in a relevant layout system such as <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">Grid</a> or <a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout">Flexbox</a>. If the second value is not set, the first value is also used for it.</p>

<div>{{EmbedInteractiveExample("pages/css/place-items.html")}}</div>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
 <li><a href="/en-US/docs/Web/CSS/align-items"><code>align-items</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/justify-items"><code>justify-items</code></a></li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css notranslate">/* Keyword values */
place-items: auto center;
place-items: normal start;

/* Positional alignment */
place-items: center normal;
place-items: start auto;
place-items: end normal;
place-items: self-start auto;
place-items: self-end normal;
place-items: flex-start auto;
place-items: flex-end normal;
place-items: left auto;
place-items: right normal;

/* Baseline alignment */
place-items: baseline normal;
place-items: first baseline auto;
place-items: last baseline normal;
place-items: stretch auto;

/* Global values */
place-items: inherit;
place-items: initial;
place-items: unset;
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>auto</code></dt>
 <dd>The value used is the value of the <code>justify-items</code> property of the parents box, unless the box has no parent, or is absolutely positioned, in these cases, <code>auto</code> represents <code>normal</code>.</dd>
 <dt><code>normal</code></dt>
 <dd>The effect of this keyword is dependent of the layout mode we are in:
 <ul>
  <li>In block-level layouts, the keyword is a synonym of <code>start</code>.</li>
  <li>In absolutely-positioned layouts, the keyword behaved like <code>start</code> on <em>replaced</em> absolutely-positioned boxes, and as <code>stretch</code> on <em>all other</em> absolutely-positioned boxes.</li>
  <li>In table cell layouts, this keyword has no meaning as this property is <em>ignored</em>.</li>
  <li>In flexbox layouts, this keyword has no meaning as this property is <em>ignored.</em></li>
  <li>In grid layouts, this keyword leads to a behavior similar to the one of <code>stretch</code>, except for boxes with an aspect ratio or an intrinsic sizes where it behaves like <code>start</code>.</li>
 </ul>
 </dd>
 <dt><code>start</code></dt>
 <dd>The item is packed flush to each other toward the start edge of the alignment container in the appropriate axis.</dd>
 <dt><code>end</code></dt>
 <dd>The item is packed flush to each other toward the end edge of the alignment container in the appropriate axis.</dd>
 <dt><code>flex-start</code></dt>
 <dd>The item is packed flush to each other toward the edge of the alignment container depending on the flex container's main-start or cross-start side.<br>
 This only applies to flex layout items. For items that are not children of a flex container, this value is treated like <code>start</code>.</dd>
 <dt><code>flex-end</code></dt>
 <dd>The item is packed flush to each other toward the edge of the alignment container depending on the flex container's main-end or cross-end side.<br>
 This only applies to flex layout items. For items that are not children of a flex container, this value is treated like <code>end</code>.</dd>
 <dt><code>self-start</code></dt>
 <dd>The item is packed flush to the edge of the alignment container of the start side of the item, in the appropriate axis.</dd>
 <dt><code>self-end</code></dt>
 <dd>The item is packed flush to the edge of the alignment container of the end side of the item, in the appropriate axis.</dd>
 <dt><code>center</code></dt>
 <dd>The items are packed flush to each other toward the center of the of the alignment container.</dd>
 <dt><code>left</code></dt>
 <dd>The items are packed flush to each other toward the left edge of the alignment container. If the property’s axis is not parallel with the inline axis, this value behaves like <code>start</code>.</dd>
 <dt><code>right</code></dt>
 <dd>The items are packed flush to each other toward the right edge of the alignment container in the appropriate axis. If the property’s axis is not parallel with the inline axis, this value behaves like <code>start</code>.</dd>
 <dt><code>baseline<br>
 first baseline</code><br>
 <code>last baseline</code></dt>
 <dd>Specifies participation in first- or last-baseline alignment: aligns the alignment baseline of the box’s first or last baseline set with the corresponding baseline in the shared first or last baseline set of all the boxes in its baseline-sharing group.<br>
 The fallback alignment for <code>first baseline</code> is <code>start</code>, the one for <code>last baseline</code> is <code>end</code>.</dd>
 <dt><code>stretch</code></dt>
 <dd>If the combined size of the items is less than the size of the alignment container, any <code>auto</code>-sized items have their size increased equally (not proportionally), while still respecting the constraints imposed by {{CSSxRef("max-height")}}/{{CSSxRef("max-width")}} (or equivalent functionality), so that the combined size exactly fills the alignment container.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Placing_items_in_a_flex_container">Placing items in a flex container</h3>

<div class="hidden">
<pre class="brush: css; notranslate">div &gt; div {
  box-sizing: border-box;
  border: 2px solid #8c8c8c;
  width: 50px;
  display: flex;
  align-items: center;
  justify-content: center;
}

#item1 {
  background-color: #8cffa0;
  min-height: 30px;
}

#item2 {
  background-color: #a0c8ff;
  min-height: 50px;
}

#item3 {
  background-color: #ffa08c;
  min-height: 40px;
}

#item4 {
  background-color: #ffff8c;
  min-height: 60px;
}

#item5 {
  background-color: #ff8cff;
  min-height: 70px;
}

#item6 {
  background-color: #8cffff;
  min-height: 50px;
  font-size: 30px;
}

select {
  font-size: 16px;
}

.row {
  margin-top: 10px;
}</pre>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="container" class="flex"&gt;
  &lt;div id="item1"&gt;1&lt;/div&gt;
  &lt;div id="item2"&gt;2&lt;/div&gt;
  &lt;div id="item3"&gt;3&lt;/div&gt;
  &lt;div id="item4"&gt;4&lt;/div&gt;
  &lt;div id="item5"&gt;5&lt;/div&gt;
  &lt;div id="item6"&gt;6&lt;/div&gt;
&lt;/div&gt;

&lt;div class="row"&gt;
  &lt;label for="display"&gt;display: &lt;/label&gt;
  &lt;select id="display"&gt;
    &lt;option value="flex"&gt;flex&lt;/option&gt;
    &lt;option value="grid"&gt;grid&lt;/option&gt;
  &lt;/select&gt;
&lt;/div&gt;

&lt;div class="row"&gt;
  &lt;label for="values"&gt;place-items: &lt;/label&gt;
  &lt;select id="values"&gt;
    &lt;option value="start"&gt;start&lt;/option&gt;
    &lt;option value="center"&gt;center&lt;/option&gt;
    &lt;option value="end"&gt;end&lt;/option&gt;
    &lt;option value="left"&gt;left&lt;/option&gt;
    &lt;option value="right"&gt;right&lt;/option&gt;
    &lt;option value="auto center"&gt;auto center&lt;/option&gt;
    &lt;option value="normal start"&gt;normal start&lt;/option&gt;
    &lt;option value="center normal"&gt;center normal&lt;/option&gt;
    &lt;option value="start auto"&gt;start auto&lt;/option&gt;
    &lt;option value="end normal"&gt;end normal&lt;/option&gt;
    &lt;option value="self-start auto"&gt;self-start auto&lt;/option&gt;
    &lt;option value="self-end normal"&gt;self-end normal&lt;/option&gt;
    &lt;option value="flex-start auto"&gt;flex-start auto&lt;/option&gt;
    &lt;option value="flex-end normal"&gt;flex-end normal&lt;/option&gt;
    &lt;option value="left auto"&gt;left auto&lt;/option&gt;
    &lt;option value="right normal"&gt;right normal&lt;/option&gt;
    &lt;option value="baseline normal"&gt;baseline normal&lt;/option&gt;
    &lt;option value="first baseline auto"&gt;first baseline auto&lt;/option&gt;
    &lt;option value="last baseline normal"&gt;last baseline normal&lt;/option&gt;
    &lt;option value="stretch auto"&gt;stretch auto&lt;/option&gt;
  &lt;/select&gt;
&lt;/div&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">var values = document.getElementById('values');
var display = document.getElementById('display');
var container = document.getElementById('container');

values.addEventListener('change', function (evt) {
  container.style.placeItems = evt.target.value;
});

display.addEventListener('change', function (evt) {
  container.className = evt.target.value;
});
</pre>
</div>

<h4 id="CSS">CSS</h4>

<pre class="brush: css; highlight[4] notranslate">#container {
  height:200px;
  width: 240px;
  place-items: center; /* You can change this value by selecting another option in the list */
  background-color: #8c8c8c;
}

.flex {
  display: flex;
  flex-wrap: wrap;
}

.grid {
  display: grid;
  grid-template-columns: repeat(auto-fill, 50px);
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Placing_items_in_a_flex_container", 260, 290)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS3 Box Alignment", "#place-items-property", "place-items")}}</td>
   <td>{{Spec2("CSS3 Box Alignment")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.place-items")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>CSS Flexbox Guide: <em><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Basic_Concepts_of_Flexbox">Basic Concepts of Flexbox</a></em></li>
 <li>CSS Flexbox Guide: <em><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Aligning_Items_in_a_Flex_Container">Aligning items in a flex container</a></em></li>
 <li>CSS Grid Guide: <em><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">Box alignment in CSS Grid layouts</a></em></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Box_Alignment">CSS Box Alignment</a></li>
 <li>The {{CSSxRef("align-items")}} property</li>
 <li>The {{CSSxRef("align-self")}} property</li>
 <li>The {{CSSxRef("justify-items")}} property</li>
 <li>The {{CSSxRef("justify-self")}} property</li>
</ul>
